import json
import sys

import psycopg2
import psycopg2.extras

class StreamReader(object):
    def __init__(self):
        self.connection = psycopg2.connect("dbname=realtime",
            connection_factory=psycopg2.extras.LogicalReplicationConnection,
        )

    def __call__(self, msg):
        data = json.loads(msg.payload, strict=False)
        print(str(data))
        msg.cursor.send_feedback(flush_lsn=msg.data_start)

reader = StreamReader()
cursor = reader.connection.cursor()
cursor.start_replication(slot_name='schedule', decode=True)
try:
    cursor.consume_stream(reader)
except KeyboardInterrupt:
    print("Stopping reader...")
finally:
    cursor.close()
    reader.connection.close()
    print("Exiting reader")
