\timing

/** Create the room */
INSERT INTO room (name) VALUES ('DMS 1150');

/** Look at initial calendar on May 30, 2018 */
SELECT *
FROM calendar
WHERE calendar_date = '2018-05-30'
ORDER BY lower(calendar_range);

/** Liberty only allows bookings from 8am - 1pm, and 4pm to 10pm on Mon - Fri */
INSERT INTO availability_rule
    (room_id, days_of_week, start_time, end_time, generate_weeks_into_future)
SELECT
    room.id, ARRAY[1,2,3,4,5]::int[], times.start_time::time, times.end_time::time, 52
FROM room,
    LATERAL (
        VALUES ('8:00', '13:00'), ('16:00', '22:00')
    ) times(start_time, end_time)
WHERE room.name = 'DMS 1150';

INSERT INTO unavailability (room_id, unavailable_date, unavailable_range)
SELECT
    room.id, '2018-05-30', tstzrange('2018-05-02 9:00', '2018-05-02 11:00')
FROM room
WHERE room.name = 'DMS 1150';
